mongodb = require 'mongodb'
Collection = mongodb.Collection

STATUS_CLOSE = 0
STATUS_OPENNING = 1
STATUS_OPEN = 2

class SkinCollection
  constructor: (@db, @collectionName) ->
    #TODO: setter of @hint

  open: (fn) ->
    switch @_status 
      when STATUS_OPEN
        fn null, @nativeCollection

      when STATUS_OPENNING
        @once 'open', fn

      when STATUS_CLOSE
        that = this
        @once 'open', fn

        # start open
        @status = STATUS_OPENNING
        @db.nativeDb.collection @collectionName, (err, nativeCollection)->
          if nativeCollection
            that.status = STATUS_OPEN
            that.nativeCollection = nativeCollection
          that.emit 'open', err, nativeCollection

  findItems: (args..., fn) ->
    @find args..., (err, cursor) ->
      if err
        fn err
      else
        cursor.toArray fn

  findEach: (args..., fn) ->
    @find args..., (err, cursor) ->
      if err
        fn err
      else
        cursor.each fn

  id: (hex)->
    @db.bson_serializer.ObjectID.createFromHexString(hex)

  findById: (args...) ->
    @findOne {_id: @id(args[0])}, args[1..]...

  updateById: (args...) ->
    @update {_id: @id(args[0])}, args[1..]...

  sub: (sub) ->
    @__defineGetter__ sub, ()-> 
      @["sub-#{sub}"] or= new Provider "#{@collectionName}.#{sub}"
###
  bind these methods from Collection.prototype to Provider

  methods:
    insert
    checkCollectionName
    remove
    rename
    insertAll
    save
    update
    distinct
    count
    drop
    findAndModify
    find
    normalizeHintField
    findOne
    createIndex
    ensureIndex
    indexInformation
    dropIndex
    dropIndexes
    mapReduce
    group
    options
###
bind = (name, method) ->
  MongoProvider.prototype[name] = (args...) ->
    @collection (err, collection) ->
      if err
        args[args.length-1] err
      else
        method.apply collection, args

bind name, method for name, method of Collection.prototype

exports.MongoProvider = MongoProvider
